/***********************************************************************/
/*                                                                     */
/*                           Objective Caml                            */
/*                                                                     */
/*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         */
/*                                                                     */
/*  Copyright 2001 Institut National de Recherche en Informatique et   */
/*  en Automatique.  All rights reserved.  This file is distributed    */
/*  under the terms of the GNU Library General Public License, with    */
/*  the special exception on linking described in file LICENSE-OCAML.  */
/*                                                                     */
/***********************************************************************/

/* $Id: winerrmsg.c,v 1.504 2004/12/22 15:27:08 zappa Exp $
 *
*** Copyright 2002-2004 The Netsem Team

    * Steve Bishop
    * Michael Compton
    * Matthew Fairbairn
    * Michael Norrish
    * Andrei Serjantov
    * Peter Sewell
    * Michael Smith
    * Keith Wansbrough

All rights reserved.

This file is distributed under the terms of the GNU Lesser General
Public License, with the special exception on linking described in
file NEW-LICENSE.

***
 *
*** Copyright 2002-2004 The Acute Team

  Allen-Williams, Mair
  Bishop, Steven
  Fairbairn, Matthew
  Habouzit, Pierre [*]
  Leifer, James [*]
  Sewell, Peter
  Sjberg, Vilhelm
  Steinruecken, Christian
  Vafeiadis, Viktor
  Wansbrough, Keith
  Zappa Nardelli, Francesco [*]
  Institut National de Recherche en Informatique et en Automatique (INRIA)

  Contributions of authors marked [*] are copyright INRIA.

All rights reserved.

This file is distributed under the terms of the GNU Lesser General
Public License, with the special exception on linking described in
file NEW-LICENSE.

***
 * -=-- ---------------------------------------------------- --=- */

#include <errno.h>
#include <string.h>
#include <mlvalues.h>
#include <alloc.h>
#include <memory.h>
#include <misc.h>
#include "unixsupport.h"
#include <wtypes.h>
#include <winbase.h>

extern char *geterrmsg(char *dest, int errno);
extern int ns_error_table[];

CAMLprim value unix_error_message(value err)
{
  CAMLparam1(err);
  int errnum, len;
  char buffer[512];

  errnum = Is_block(err) ? Int_val(Field(err, 0)) : ns_error_table[Int_val(err)];
  if (errnum > 0)
    return copy_string(strerror(errnum));

  //call nssock function
  geterrmsg(buffer, -errnum);
  len = strlen(buffer);
  if(len > 0) {
	buffer[len] = ':';
	buffer[len+1] = ' ';
	buffer[len+2] = '\0';
  }

  if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
                    NULL, -errnum, 0, buffer+strlen(buffer),
		    sizeof(buffer) - strlen(buffer), NULL))
    CAMLreturn(copy_string(buffer));

  strcat(buffer, "unknown error");
  CAMLreturn(copy_string(buffer));
}
